Index: IOIPSL/trunk/src/getincom.f90
===================================================================
--- IOIPSL/trunk/src/getincom.f90	(revision 10)
+++ IOIPSL/trunk/src/getincom.f90	(revision 11)
@@ -758,35 +562,34 @@
 !-
   IF (pos < 0) THEN
-!-- Ge the information out of the file
-    CALL getfilc (TARGET,status,fileorig,tmp_ret_val)
+!-- Get the information out of the file
+    CALL get_fil (target,status,fileorig,l_val=tmp_ret_val)
 !-- Put the data into the database
-    CALL getdbwc (TARGET,target_sig,status,fileorig,1,tmp_ret_val)
+    CALL get_wdb &
+ &   (target,target_sig,status,fileorig,1,l_val=tmp_ret_val)
   ELSE
 !-- Get the value out of the database
-    CALL getdbrc (pos,1,TARGET,tmp_ret_val)
+    CALL get_rdb (pos,1,target,l_val=tmp_ret_val)
   ENDIF
   ret_val = tmp_ret_val(1)
 !---------------------
-END SUBROUTINE getincs
-!-
+END SUBROUTINE getinls
 !===
-!-
-SUBROUTINE getinc1d (TARGET,ret_val)
-!---------------------------------------------------------------------
-!- See getincs for details. It is the same thing but for a vector
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  CHARACTER(LEN=*),DIMENSION(:) :: ret_val
-!-
-  CHARACTER(LEN=100),DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
+SUBROUTINE getinl1d (target,ret_val)
+!---------------------------------------------------------------------
+!- See getinls for details. It is the same thing but for a vector
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  LOGICAL,DIMENSION(:) :: ret_val
+!-
+  LOGICAL,DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
   INTEGER,SAVE :: tmp_ret_size = 0
-  INTEGER :: target_sig, pos, size_of_in, status=0, fileorig
+  INTEGER :: target_sig,pos,size_of_in,status=0,fileorig
 !---------------------------------------------------------------------
 !-
 ! Compute the signature of the target
 !-
-  CALL gensig (TARGET,target_sig)
+  CALL gensig (target,target_sig)
 !-
 ! Do we have this target in our database ?
@@ -805,29 +608,27 @@
 !-
   IF (pos < 0) THEN
-!-- Ge the information out of the file
-    CALL getfilc (TARGET,status,fileorig,tmp_ret_val)
+!-- Get the information out of the file
+    CALL get_fil (target,status,fileorig,l_val=tmp_ret_val)
 !-- Put the data into the database
-    CALL getdbwc &
- &   (TARGET,target_sig,status,fileorig,size_of_in,tmp_ret_val)
+    CALL get_wdb &
+ &   (target,target_sig,status,fileorig,size_of_in,l_val=tmp_ret_val)
   ELSE
 !-- Get the value out of the database
-    CALL getdbrc (pos,size_of_in,TARGET,tmp_ret_val)
+    CALL get_rdb (pos,size_of_in,target,l_val=tmp_ret_val)
   ENDIF
   ret_val(1:size_of_in) = tmp_ret_val(1:size_of_in)
 !----------------------
-END SUBROUTINE getinc1d
-!-
+END SUBROUTINE getinl1d
 !===
-!-
-SUBROUTINE getinc2d (TARGET,ret_val)
-!---------------------------------------------------------------------
-!- See getincs for details. It is the same thing but for a matrix
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  CHARACTER(LEN=*),DIMENSION(:,:) :: ret_val
-!-
-  CHARACTER(LEN=100),DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
+SUBROUTINE getinl2d (target,ret_val)
+!---------------------------------------------------------------------
+!- See getinls for details. It is the same thing but for a matrix
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  LOGICAL,DIMENSION(:,:) :: ret_val
+!-
+  LOGICAL,DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
   INTEGER,SAVE :: tmp_ret_size = 0
   INTEGER :: target_sig,pos,size_of_in,size_1,size_2,status=0,fileorig
@@ -837,5 +638,5 @@
 ! Compute the signature of the target
 !-
-  CALL gensig (TARGET,target_sig)
+  CALL gensig (target,target_sig)
 !-
 ! Do we have this target in our database ?
@@ -863,300 +664,12 @@
 !-
   IF (pos < 0) THEN
-!-- Ge the information out of the file
-    CALL getfilc (TARGET,status,fileorig,tmp_ret_val)
+!-- Get the information out of the file
+    CALL get_fil (target,status,fileorig,l_val=tmp_ret_val)
 !-- Put the data into the database
-    CALL getdbwc &
- &   (TARGET,target_sig,status,fileorig,size_of_in,tmp_ret_val)
+    CALL get_wdb &
+ &   (target,target_sig,status,fileorig,size_of_in,l_val=tmp_ret_val)
   ELSE
 !-- Get the value out of the database
-    CALL getdbrc (pos,size_of_in,TARGET,tmp_ret_val)
-  ENDIF
-!-
-  jl=0
-  DO jj=1,size_2
-    DO ji=1,size_1
-      jl=jl+1
-      ret_val(ji,jj) = tmp_ret_val(jl)
-    ENDDO
-  ENDDO
-!----------------------
-END SUBROUTINE getinc2d
-!-
-!===
-!-
-SUBROUTINE getfilc (TARGET,status,fileorig,ret_val)
-!---------------------------------------------------------------------
-!- Subroutine that will extract from the file the values
-!- attributed to the keyword target
-!-
-!- CHARACTER
-!- ---------
-!-
-!- target   : in  : CHARACTER(LEN=*)  target for which we will
-!-                                    look in the file
-!- status   : out : INTEGER tells us from where we obtained the data
-!- fileorig : out : The index of the file from which the key comes
-!- ret_val  : out : CHARACTER(nb_to_ret) values read
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-!-
-  CHARACTER(LEN=*) :: TARGET
-  INTEGER :: status, fileorig
-  CHARACTER(LEN=*),DIMENSION(:) :: ret_val
-!-
-  INTEGER :: nb_to_ret
-  INTEGER :: it, pos, len_str, status_cnt
-  CHARACTER(LEN=3)  :: cnt
-  CHARACTER(LEN=30) :: full_target
-  CHARACTER(LEN=80) :: str_READ, str_READ_lower, str_tmp
-  INTEGER :: full_target_sig
-!-
-  INTEGER,SAVE :: max_len = 0
-  LOGICAL,DIMENSION(:),SAVE,ALLOCATABLE :: found
-  LOGICAL,SAVE :: def_beha
-!---------------------------------------------------------------------
-  nb_to_ret = SIZE(ret_val)
-  CALL getin_read
-!-
-! Get the variables and memory we need
-!-
-  IF (max_len == 0) THEN
-    ALLOCATE(found(nb_to_ret))
-    max_len = nb_to_ret
-  ENDIF
-  IF (max_len < nb_to_ret) THEN
-    DEALLOCATE(found)
-    ALLOCATE(found(nb_to_ret))
-    max_len = nb_to_ret
-  ENDIF
-  found(:) = .FALSE.
-!-
-! See what we find in the files read
-!-
-  DO it=1,nb_to_ret
-!---
-!-- First try the target as it is
-    full_target = TARGET(1:len_TRIM(target))
-    CALL gensig (full_target,full_target_sig)
-    CALL find_sig (nb_lines,targetlist,full_target, &
- &                 targetsiglist,full_target_sig,pos)
-!---
-!-- Another try
-!---
-    IF (pos < 0) THEN
-      WRITE(cnt,'(I3.3)') it
-      full_target = TARGET(1:len_TRIM(target))//'__'//cnt
-      CALL gensig (full_target,full_target_sig)
-      CALL find_sig (nb_lines,targetlist,full_target, &
- &                   targetsiglist,full_target_sig,pos)
-    ENDIF
-!---
-!-- A priori we dont know from which file the target could come.
-!-- Thus by default we attribute it to the first file :
-!---
-    fileorig = 1
-!---
-    IF (pos > 0) THEN
-!-----
-      found(it) = .TRUE.
-      fileorig = fromfile(pos)
-!-----
-!---- DECODE
-!-----
-      str_READ = TRIM(ADJUSTL(fichier(pos)))
-      str_READ_lower = str_READ
-      CALL strlowercase (str_READ_lower)
-!-----
-      IF (    (     (INDEX(str_READ_lower,'def') == 1)     &
- &             .AND.(LEN_TRIM(str_READ_lower) == 3)   )    &
- &        .OR.(     (INDEX(str_READ_lower,'default') == 1) &
- &             .AND.(LEN_TRIM(str_READ_lower) == 7)   )   ) THEN
-        def_beha = .TRUE.
-      ELSE
-        def_beha = .FALSE.
-        len_str = LEN_TRIM(str_READ)
-        ret_val(it) = str_READ(1:len_str)
-      ENDIF
-!-----
-      targetsiglist(pos) = -1
-!-----
-    ELSE
-      found(it) = .FALSE.
-    ENDIF
-  ENDDO
-!-
-! Now we get the status for what we found
-!-
-  IF (def_beha) THEN
-    status = 2
-    WRITE(*,*) 'USING DEFAULT BEHAVIOUR FOR ',TRIM(TARGET)
-  ELSE
-    status_cnt = 0
-    DO it=1,nb_to_ret
-      IF (.NOT. found(it)) THEN
-        status_cnt = status_cnt+1
-        IF (nb_to_ret > 1) THEN
-          WRITE(str_tmp,'(a,"__",I3.3)') TRIM(TARGET),it
-        ELSE
-          str_tmp = TARGET(1:len_TRIM(target))
-        ENDIF
-        WRITE(*,*) 'USING DEFAULTS : ',TRIM(str_tmp),'=',ret_val(it)
-      ENDIF
-    ENDDO
-!-
-    IF (status_cnt == 0) THEN
-      status = 1
-    ELSE IF (status_cnt == nb_to_ret) THEN
-      status = 2
-    ELSE
-      status = 3
-    ENDIF
-  ENDIF
-!---------------------
-END SUBROUTINE getfilc
-!-
-!=== LOGICAL INTERFACES
-!-
-SUBROUTINE getinls (TARGET,ret_val)
-!---------------------------------------------------------------------
-!- Get a logical scalar. We first check if we find it
-!- in the database and if not we get it from the run.def
-!-
-!- getinl1d and getinl2d are written on the same pattern
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  LOGICAL :: ret_val
-!-
-  LOGICAL,DIMENSION(1) :: tmp_ret_val
-  INTEGER :: target_sig, pos, status=0, fileorig
-!---------------------------------------------------------------------
-!-
-! Compute the signature of the target
-!-
-  CALL gensig (TARGET,target_sig)
-!-
-! Do we have this target in our database ?
-!-
-  CALL find_sig (nb_keys,keystr,target,keysig,target_sig,pos)
-!-
-  tmp_ret_val(1) = ret_val
-!-
-  IF (pos < 0) THEN
-!-- Ge the information out of the file
-    CALL getfill (TARGET,status,fileorig,tmp_ret_val)
-!-- Put the data into the database
-    CALL getdbwl (TARGET,target_sig,status,fileorig,1,tmp_ret_val)
-  ELSE
-!-- Get the value out of the database
-    CALL getdbrl (pos,1,TARGET,tmp_ret_val)
-  ENDIF
-  ret_val = tmp_ret_val(1)
-!---------------------
-END SUBROUTINE getinls
-!-
-!===
-!-
-SUBROUTINE getinl1d (TARGET,ret_val)
-!---------------------------------------------------------------------
-!- See getinls for details. It is the same thing but for a vector
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  LOGICAL,DIMENSION(:) :: ret_val
-!-
-  LOGICAL,DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
-  INTEGER,SAVE :: tmp_ret_size = 0
-  INTEGER :: target_sig, pos, size_of_in, status=0, fileorig
-!---------------------------------------------------------------------
-!-
-! Compute the signature of the target
-!-
-  CALL gensig (TARGET,target_sig)
-!-
-! Do we have this target in our database ?
-!-
-  CALL find_sig (nb_keys,keystr,target,keysig,target_sig,pos)
-!-
-  size_of_in = SIZE(ret_val)
-  IF (.NOT.ALLOCATED(tmp_ret_val)) THEN
-    ALLOCATE (tmp_ret_val(size_of_in))
-  ELSE IF (size_of_in > tmp_ret_size) THEN
-    DEALLOCATE (tmp_ret_val)
-    ALLOCATE (tmp_ret_val(size_of_in))
-    tmp_ret_size = size_of_in
-  ENDIF
-  tmp_ret_val(1:size_of_in) = ret_val(1:size_of_in)
-!-
-  IF (pos < 0) THEN
-!-- Ge the information out of the file
-    CALL getfill (TARGET,status,fileorig,tmp_ret_val)
-!-- Put the data into the database
-    CALL getdbwl &
- &   (TARGET,target_sig,status,fileorig,size_of_in,tmp_ret_val)
-  ELSE
-!-- Get the value out of the database
-    CALL getdbrl (pos,size_of_in,TARGET,tmp_ret_val)
-  ENDIF
-  ret_val(1:size_of_in) = tmp_ret_val(1:size_of_in)
-!----------------------
-END SUBROUTINE getinl1d
-!-
-!===
-!-
-SUBROUTINE getinl2d (TARGET,ret_val)
-!---------------------------------------------------------------------
-!- See getinls for details. It is the same thing but for a matrix
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  LOGICAL,DIMENSION(:,:) :: ret_val
-!-
-  LOGICAL,DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
-  INTEGER,SAVE :: tmp_ret_size = 0
-  INTEGER :: target_sig,pos,size_of_in,size_1,size_2,status=0,fileorig
-  INTEGER :: jl,jj,ji
-!---------------------------------------------------------------------
-!-
-! Compute the signature of the target
-!-
-  CALL gensig (TARGET,target_sig)
-!-
-! Do we have this target in our database ?
-!-
-  CALL find_sig (nb_keys,keystr,target,keysig,target_sig,pos)
-!-
-  size_of_in = SIZE(ret_val)
-  size_1 = SIZE(ret_val,1)
-  size_2 = SIZE(ret_val,2)
-  IF (.NOT.ALLOCATED(tmp_ret_val)) THEN
-    ALLOCATE (tmp_ret_val(size_of_in))
-  ELSE IF (size_of_in > tmp_ret_size) THEN
-    DEALLOCATE (tmp_ret_val)
-    ALLOCATE (tmp_ret_val(size_of_in))
-    tmp_ret_size = size_of_in
-  ENDIF
-!-
-  jl=0
-  DO jj=1,size_2
-    DO ji=1,size_1
-      jl=jl+1
-      tmp_ret_val(jl) = ret_val(ji,jj)
-    ENDDO
-  ENDDO
-!-
-  IF (pos < 0) THEN
-!-- Ge the information out of the file
-    CALL getfill (TARGET,status,fileorig,tmp_ret_val)
-!-- Put the data into the database
-    CALL getdbwl &
- &   (TARGET,target_sig,status,fileorig,size_of_in,tmp_ret_val)
-  ELSE
-!-- Get the value out of the database
-    CALL getdbrl (pos,size_of_in,TARGET,tmp_ret_val)
+    CALL get_rdb (pos,size_of_in,target,l_val=tmp_ret_val)
   ENDIF
 !-
@@ -1171,60 +684,70 @@
 END SUBROUTINE getinl2d
 !-
-!===
-!-
-SUBROUTINE getfill (TARGET,status,fileorig,ret_val)
+!=== Generic file/database INTERFACE
+!-
+SUBROUTINE get_fil (target,status,fileorig,i_val,r_val,c_val,l_val)
 !---------------------------------------------------------------------
 !- Subroutine that will extract from the file the values
 !- attributed to the keyword target
 !-
-!- LOGICAL
-!- -------
-!-
-!- target   : in  : CHARACTER(LEN=*)  target for which we will
-!-                                    look in the file
-!- status   : out : INTEGER tells us from where we obtained the data
-!- fileorig : out : The index of the file from which the key comes
-!- ret_val  : out : LOGICAL(nb_to_ret) values read
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  INTEGER :: status, fileorig
-  LOGICAL,DIMENSION(:) :: ret_val
-!-
-  INTEGER :: nb_to_ret
-  INTEGER :: it, pos, len_str, ipos_tr, ipos_fl, status_cnt
-  CHARACTER(LEN=3)  :: cnt
-  CHARACTER(LEN=30) :: full_target
-  CHARACTER(LEN=80) :: str_READ, str_READ_lower, str_tmp
+!- (C) target    : target for which we will look in the file
+!- (I) status    : tells us from where we obtained the data
+!- (I) fileorig  : index of the file from which the key comes
+!- (I) i_val(:)  : INTEGER(nb_to_ret)   values
+!- (R) r_val(:)  : REAL(nb_to_ret)      values
+!- (L) l_val(:)  : LOGICAL(nb_to_ret)   values
+!- (C) c_val(:)  : CHARACTER(nb_to_ret) values
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  INTEGER,INTENT(OUT) :: status,fileorig
+  INTEGER,DIMENSION(:),OPTIONAL          :: i_val
+  REAL,DIMENSION(:),OPTIONAL             :: r_val
+  LOGICAL,DIMENSION(:),OPTIONAL          :: l_val
+  CHARACTER(LEN=*),DIMENSION(:),OPTIONAL :: c_val
+!-
+  INTEGER :: k_typ,nb_to_ret,it,pos,len_str,status_cnt,io_err
+  CHARACTER(LEN=n_d_fmt)  :: cnt
+  CHARACTER(LEN=37) :: full_target
+  CHARACTER(LEN=80) :: str_READ,str_READ_lower
+  CHARACTER(LEN=9)  :: c_vtyp
   INTEGER :: full_target_sig
-!-
-  INTEGER,SAVE :: max_len = 0
-  LOGICAL,DIMENSION(:),SAVE,ALLOCATABLE :: found
-  LOGICAL,SAVE :: def_beha
-!---------------------------------------------------------------------
-  nb_to_ret = SIZE(ret_val)
+  LOGICAL,DIMENSION(:),ALLOCATABLE :: found
+  LOGICAL :: def_beha,compressed
+  CHARACTER(LEN=10) :: c_fmt
+  INTEGER :: i_cmpval
+  REAL    :: r_cmpval
+  INTEGER :: ipos_tr,ipos_fl
+!---------------------------------------------------------------------
+!-
+! Get the type of the argument
+  CALL get_qtyp (k_typ,c_vtyp,i_val,r_val,c_val,l_val)
+  SELECT CASE (k_typ)
+  CASE(k_i)
+    nb_to_ret = SIZE(i_val)
+  CASE(k_r)
+    nb_to_ret = SIZE(r_val)
+  CASE(k_c)
+    nb_to_ret = SIZE(c_val)
+  CASE(k_l)
+    nb_to_ret = SIZE(l_val)
+  CASE DEFAULT
+    CALL ipslerr (3,'get_fil', &
+ &   'Internal error','Unknown type of data',' ')
+  END SELECT
+!-
+! Read the file(s)
   CALL getin_read
 !-
-! Get the variables and memory we need
-!-
-  IF (max_len == 0) THEN
-    ALLOCATE(found(nb_to_ret))
-    max_len = nb_to_ret
-  ENDIF
-  IF (max_len < nb_to_ret) THEN
-    DEALLOCATE(found)
-    ALLOCATE(found(nb_to_ret))
-    max_len = nb_to_ret
-  ENDIF
+! Allocate and initialize the memory we need
+  ALLOCATE(found(nb_to_ret))
   found(:) = .FALSE.
 !-
 ! See what we find in the files read
-!-
   DO it=1,nb_to_ret
 !---
 !-- First try the target as it is
-!---
-    full_target = TARGET(1:len_TRIM(target))
+    full_target = target
     CALL gensig (full_target,full_target_sig)
     CALL find_sig (nb_lines,targetlist,full_target, &
@@ -1234,6 +757,6 @@
 !---
     IF (pos < 0) THEN
-      WRITE(cnt,'(I3.3)') it
-      full_target = TARGET(1:len_TRIM(target))//'__'//cnt
+      WRITE(UNIT=cnt,FMT=c_i_fmt) it
+      full_target = TRIM(target)//'__'//cnt
       CALL gensig (full_target,full_target_sig)
       CALL find_sig (nb_lines,targetlist,full_target, &
@@ -1241,7 +764,6 @@
     ENDIF
 !---
-!-- A priori we dont know from which file the target could come.
+!-- We dont know from which file the target could come.
 !-- Thus by default we attribute it to the first file :
-!---
     fileorig = 1
 !---
@@ -1253,32 +775,44 @@
 !---- DECODE
 !-----
-      str_READ = TRIM(ADJUSTL(fichier(pos)))
+      str_READ = ADJUSTL(fichier(pos))
       str_READ_lower = str_READ
       CALL strlowercase (str_READ_lower)
 !-----
-      IF (    (     (INDEX(str_READ_lower,'def') == 1)     &
- &             .AND.(LEN_TRIM(str_READ_lower) == 3)   )    &
- &        .OR.(     (INDEX(str_READ_lower,'default') == 1) &
- &             .AND.(LEN_TRIM(str_READ_lower) == 7)   )   ) THEN
+      IF (    (TRIM(str_READ_lower) == 'def')     &
+ &        .OR.(TRIM(str_READ_lower) == 'default') ) THEN
         def_beha = .TRUE.
       ELSE
         def_beha = .FALSE.
         len_str = LEN_TRIM(str_READ)
-        ipos_tr = -1
-        ipos_fl = -1
-!-------
-        ipos_tr = MAX(INDEX(str_READ,'tru'),INDEX(str_READ,'TRU'), &
- &                    INDEX(str_READ,'y'),INDEX(str_READ,'Y'))
-        ipos_fl = MAX(INDEX(str_READ,'fal'),INDEX(str_READ,'FAL'), &
- &                    INDEX(str_READ,'n'),INDEX(str_READ,'N'))
-!-------
-        IF (ipos_tr > 0) THEN
-          ret_val(it) = .TRUE.
-        ELSE IF (ipos_fl > 0) THEN
-          ret_val(it) = .FALSE.
-        ELSE
-          WRITE(*,*) "ERROR : getfill : TARGET ", &
- &                   TRIM(TARGET)," is not of logical value"
-          STOP 'getinl'
+        io_err = 0
+        SELECT CASE (k_typ)
+        CASE(k_i)
+          WRITE (UNIT=c_fmt,FMT='("(I",I3.3,")")') len_str
+          READ (UNIT=str_READ(1:len_str), &
+ &              FMT=c_fmt,IOSTAT=io_err) i_val(it)
+        CASE(k_r)
+          READ (UNIT=str_READ(1:len_str), &
+ &              FMT=*,IOSTAT=io_err) r_val(it)
+        CASE(k_c)
+          c_val(it) = str_READ(1:len_str)
+        CASE(k_l)
+          ipos_tr = -1
+          ipos_fl = -1
+          ipos_tr = MAX(INDEX(str_READ_lower,'tru'), &
+ &                      INDEX(str_READ_lower,'y'))
+          ipos_fl = MAX(INDEX(str_READ_lower,'fal'), &
+ &                      INDEX(str_READ_lower,'n'))
+          IF (ipos_tr > 0) THEN
+            l_val(it) = .TRUE.
+          ELSE IF (ipos_fl > 0) THEN
+            l_val(it) = .FALSE.
+          ELSE
+            io_err = 100
+          ENDIF
+        END SELECT
+        IF (io_err /= 0) THEN
+          CALL ipslerr (3,'get_fil', &
+ &         'Target '//TRIM(target), &
+ &         'is not of '//TRIM(c_vtyp)//' type',' ')
         ENDIF
       ENDIF
@@ -1286,28 +820,74 @@
       targetsiglist(pos) = -1
 !-----
+      IF ( (k_typ == k_i).OR.(k_typ == k_r) ) THEN
+!-------
+!------ Is this the value of a compressed field ?
+        compressed = (compline(pos) > 0)
+        IF (compressed) THEN
+          IF (compline(pos) /= nb_to_ret) THEN
+            CALL ipslerr (2,'get_fil', &
+ &           'For key '//TRIM(target)//' we have a compressed field', &
+ &           'which does not have the right size.', &
+ &           'We will try to fix that.')
+          ENDIF
+          IF      (k_typ == k_i) THEN
+            i_cmpval = i_val(it)
+          ELSE IF (k_typ == k_r) THEN
+            r_cmpval = r_val(it)
+          ENDIF
+        ENDIF
+      ENDIF
     ELSE
-!-
       found(it) = .FALSE.
-!-
-    ENDIF
-!-
+      def_beha = .FALSE.
+      compressed = .FALSE.
+    ENDIF
   ENDDO
 !-
-! Now we get the status for what we found
-!-
+  IF ( (k_typ == k_i).OR.(k_typ == k_r) ) THEN
+!---
+!-- If this is a compressed field then we will uncompress it
+    IF (compressed) THEN
+      DO it=1,nb_to_ret
+        IF (.NOT.found(it)) THEN
+          IF      (k_typ == k_i) THEN
+            i_val(it) = i_cmpval
+          ELSE IF (k_typ == k_r) THEN
+          ENDIF
+          found(it) = .TRUE.
+        ENDIF
+      ENDDO
+    ENDIF
+  ENDIF
+!-
+! Now we set the status for what we found
   IF (def_beha) THEN
     status = 2
-    WRITE(*,*) 'USING DEFAULT BEHAVIOUR FOR ',TRIM(TARGET)
+    WRITE(*,*) 'USING DEFAULT BEHAVIOUR FOR ',TRIM(target)
   ELSE
     status_cnt = 0
     DO it=1,nb_to_ret
-      IF (.NOT. found(it)) THEN
+      IF (.NOT.found(it)) THEN
         status_cnt = status_cnt+1
-        IF (nb_to_ret > 1) THEN
-          WRITE(str_tmp,'(a,"__",I3.3)') TRIM(TARGET),it
-        ELSE
-          str_tmp = TRIM(TARGET)
+        IF      (status_cnt <= max_msgs) THEN
+          WRITE (UNIT=*,FMT='(" USING DEFAULTS : ",A)', &
+ &               ADVANCE='NO') TRIM(target)
+          IF (nb_to_ret > 1) THEN
+            WRITE (UNIT=*,FMT='("__")',ADVANCE='NO')
+            WRITE (UNIT=*,FMT=c_i_fmt,ADVANCE='NO') it
+          ENDIF
+          SELECT CASE (k_typ)
+          CASE(k_i)
+            WRITE (UNIT=*,FMT=*) "=",i_val(it)
+          CASE(k_r)
+            WRITE (UNIT=*,FMT=*) "=",r_val(it)
+          CASE(k_c)
+            WRITE (UNIT=*,FMT=*) "=",c_val(it)
+          CASE(k_l)
+            WRITE (UNIT=*,FMT=*) "=",l_val(it)
+          END SELECT
+        ELSE IF (status_cnt == max_msgs+1) THEN
+          WRITE (UNIT=*,FMT='(" USING DEFAULTS ... ",A)')
         ENDIF
-        WRITE(*,*) 'USING DEFAULTS : ',TRIM(str_tmp),'=',ret_val(it)
       ENDIF
     ENDDO
@@ -1321,8 +901,168 @@
     ENDIF
   ENDIF
+! Deallocate the memory
+  DEALLOCATE(found)
 !---------------------
-END SUBROUTINE getfill
-!-
+END SUBROUTINE get_fil
 !===
+SUBROUTINE get_rdb (pos,size_of_in,target,i_val,r_val,c_val,l_val)
+!---------------------------------------------------------------------
+!- Read the required variable in the database
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  INTEGER :: pos,size_of_in
+  CHARACTER(LEN=*) :: target
+  INTEGER,DIMENSION(:),OPTIONAL          :: i_val
+  REAL,DIMENSION(:),OPTIONAL             :: r_val
+  LOGICAL,DIMENSION(:),OPTIONAL          :: l_val
+  CHARACTER(LEN=*),DIMENSION(:),OPTIONAL :: c_val
+!-
+  INTEGER :: k_typ
+  CHARACTER(LEN=9) :: c_vtyp
+!---------------------------------------------------------------------
+!-
+! Get the type of the argument
+  CALL get_qtyp (k_typ,c_vtyp,i_val,r_val,c_val,l_val)
+  IF (     (k_typ /= k_i).AND.(k_typ /= k_r) &
+ &    .AND.(k_typ /= k_c).AND.(k_typ /= k_l) )THEN
+    CALL ipslerr (3,'get_rdb', &
+ &   'Internal error','Unknown type of data',' ')
+  ENDIF
+!-
+  IF (keytype(pos) /= k_typ) THEN
+    CALL ipslerr (3,'get_rdb', &
+ &   'Wrong data type for keyword '//TRIM(target), &
+ &   '(NOT '//TRIM(c_vtyp)//')',' ')
+  ENDIF
+!-
+  IF (keycompress(pos) > 0) THEN
+    IF (    (keycompress(pos) /= size_of_in) &
+ &      .OR.(keymemlen(pos) /= 1) ) THEN
+      CALL ipslerr (3,'get_rdb', &
+ &     'Wrong compression length','for keyword '//TRIM(target),' ')
+    ELSE
+      SELECT CASE (k_typ)
+      CASE(k_i)
+        i_val(1:size_of_in) = i_mem(keymemstart(pos))
+      CASE(k_r)
+        r_val(1:size_of_in) = r_mem(keymemstart(pos))
+      END SELECT
+    ENDIF
+  ELSE
+    IF (keymemlen(pos) /= size_of_in) THEN
+      CALL ipslerr (3,'get_rdb', &
+ &     'Wrong array length','for keyword '//TRIM(target),' ')
+    ELSE
+      SELECT CASE (k_typ)
+      CASE(k_i)
+        i_val(1:size_of_in) = &
+ &        i_mem(keymemstart(pos):keymemstart(pos)+keymemlen(pos)-1)
+      CASE(k_r)
+        r_val(1:size_of_in) = &
+ &        r_mem(keymemstart(pos):keymemstart(pos)+keymemlen(pos)-1)
+      CASE(k_c)
+        c_val(1:size_of_in) = &
+ &        c_mem(keymemstart(pos):keymemstart(pos)+keymemlen(pos)-1)
+      CASE(k_l)
+        l_val(1:size_of_in) = &
+ &        l_mem(keymemstart(pos):keymemstart(pos)+keymemlen(pos)-1)
+      END SELECT
+    ENDIF
+  ENDIF
+!---------------------
+END SUBROUTINE get_rdb
+!===
+SUBROUTINE get_wdb &
+ &  (target,target_sig,status,fileorig,size_of_in, &
+ &   i_val,r_val,c_val,l_val)
+!---------------------------------------------------------------------
+!- Write data into the data base
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  INTEGER :: target_sig,status,fileorig,size_of_in
+  INTEGER,DIMENSION(:),OPTIONAL          :: i_val
+  REAL,DIMENSION(:),OPTIONAL             :: r_val
+  LOGICAL,DIMENSION(:),OPTIONAL          :: l_val
+  CHARACTER(LEN=*),DIMENSION(:),OPTIONAL :: c_val
+!-
+  INTEGER :: k_typ
+  CHARACTER(LEN=9) :: c_vtyp
+  INTEGER :: k_mempos,k_memsize,k_len
+  LOGICAL :: l_cmp
+!---------------------------------------------------------------------
+!-
+! Get the type of the argument
+  CALL get_qtyp (k_typ,c_vtyp,i_val,r_val,c_val,l_val)
+  IF (     (k_typ /= k_i).AND.(k_typ /= k_r) &
+ &    .AND.(k_typ /= k_c).AND.(k_typ /= k_l) )THEN
+    CALL ipslerr (3,'get_wdb', &
+ &   'Internal error','Unknown type of data',' ')
+  ENDIF
+!-
+! First check if we have sufficiant space for the new key
+  IF (nb_keys+1 > keymemsize) THEN
+    CALL getin_allockeys ()
+  ENDIF
+!-
+  SELECT CASE (k_typ)
+  CASE(k_i)
+    k_mempos = i_mempos; k_memsize = i_memsize;
+    l_cmp = (MINVAL(i_val) == MAXVAL(i_val)) &
+ &         .AND.(size_of_in > compress_lim)
+  CASE(k_r)
+    k_mempos = r_mempos; k_memsize = r_memsize;
+    l_cmp = (MINVAL(r_val) == MAXVAL(r_val)) &
+ &         .AND.(size_of_in > compress_lim)
+  CASE(k_c)
+    k_mempos = c_mempos; k_memsize = c_memsize;
+    l_cmp = .FALSE.
+  CASE(k_l)
+    k_mempos = l_mempos; k_memsize = l_memsize;
+    l_cmp = .FALSE.
+  END SELECT
+!-
+! Fill out the items of the data base
+  nb_keys = nb_keys+1
+  keysig(nb_keys) = target_sig
+  keystr(nb_keys) = target(1:MIN(LEN_TRIM(target),l_n))
+  keystatus(nb_keys) = status
+  keytype(nb_keys) = k_typ
+  keyfromfile(nb_keys) = fileorig
+  keymemstart(nb_keys) = k_mempos+1
+  IF (l_cmp) THEN
+    keycompress(nb_keys) = size_of_in
+    keymemlen(nb_keys) = 1
+  ELSE
+    keycompress(nb_keys) = -1
+    keymemlen(nb_keys) = size_of_in
+  ENDIF
+!-
+! Before writing the actual size lets see if we have the space
+  IF (keymemstart(nb_keys)+keymemlen(nb_keys) > k_memsize) THEN
+    CALL getin_allocmem (k_typ,keymemlen(nb_keys))
+  ENDIF
+!-
+  k_len = keymemstart(nb_keys)+keymemlen(nb_keys)-1
+  SELECT CASE (k_typ)
+  CASE(k_i)
+    i_mem(keymemstart(nb_keys):k_len) = i_val(1:keymemlen(nb_keys))
+    i_mempos = k_len
+  CASE(k_r)
+    r_mem(keymemstart(nb_keys):k_len) = r_val(1:keymemlen(nb_keys))
+    r_mempos = k_len
+  CASE(k_c)
+    c_mem(keymemstart(nb_keys):k_len) = c_val(1:keymemlen(nb_keys))
+    c_mempos = k_len
+  CASE(k_l)
+    l_mem(keymemstart(nb_keys):k_len) = l_val(1:keymemlen(nb_keys))
+    l_mempos = k_len
+  END SELECT
+!---------------------
+END SUBROUTINE get_wdb
+!-
+!===
 !-
 SUBROUTINE getin_read
@@ -1331,13 +1071,13 @@
 !-
   INTEGER,SAVE :: allread=0
-  INTEGER,SAVE :: current,i
+  INTEGER,SAVE :: current
 !---------------------------------------------------------------------
   IF (allread == 0) THEN
 !-- Allocate a first set of memory.
     CALL getin_allockeys
-    CALL getin_allocmem (1,0)
-    CALL getin_allocmem (2,0)
-    CALL getin_allocmem (3,0)
-    CALL getin_allocmem (4,0)
+    CALL getin_allocmem (k_i,0)
+    CALL getin_allocmem (k_r,0)
+    CALL getin_allocmem (k_c,0)
+    CALL getin_allocmem (k_l,0)
 !-- Start with reading the files
     nbfiles = 1
@@ -1368,9 +1108,10 @@
   INTEGER :: current
 !-
-  CHARACTER(LEN=100) :: READ_str, NEW_str, new_key, last_key, key_str
-  CHARACTER(LEN=3) :: cnt
+  CHARACTER(LEN=100) :: READ_str,NEW_str,last_key,key_str
+  CHARACTER(LEN=n_d_fmt) :: cnt
+  CHARACTER(LEN=10) :: c_fmt
   INTEGER :: nb_lastkey
 !-
-  INTEGER :: eof, ptn, len_str, i, it, iund
+  INTEGER :: eof,ptn,len_str,i,it,iund,io_err
   LOGICAL :: check = .FALSE.
 !---------------------------------------------------------------------
@@ -1383,5 +1124,10 @@
   ENDIF
 !-
-  OPEN (22,file=filelist(current),ERR=9997,STATUS="OLD")
+  OPEN (UNIT=22,FILE=filelist(current),STATUS="OLD",IOSTAT=io_err)
+  IF (io_err /= 0) THEN
+    CALL ipslerr (2,'getin_readdef', &
+ &  'Could not open file '//TRIM(filelist(current)),' ',' ')
+    RETURN
+  ENDIF
 !-
   DO WHILE (eof /= 1)
@@ -1394,25 +1140,18 @@
 !---- Get the target
       key_str = TRIM(ADJUSTL(READ_str(1:ptn-1)))
-!---- Make sure that if a vector keyword has the right length
-      iund =  INDEX(key_str,'__')
+!---- Make sure that a vector keyword has the right length
+      iund = INDEX(key_str,'__')
       IF (iund > 0) THEN
-        SELECTCASE( len_trim(key_str)-iund )
-          CASE(2)
-            READ(key_str(iund+2:len_trim(key_str)),'(I1)') it
-          CASE(3)
-            READ(key_str(iund+2:len_trim(key_str)),'(I2)') it
-          CASE(4)
-            READ(key_str(iund+2:len_trim(key_str)),'(I3)') it
-          CASE DEFAULT
-            it = -1
-        END SELECT
-        IF (it > 0) THEN
-          WRITE(cnt,'(I3.3)') it
+        WRITE (UNIT=c_fmt,FMT='("(I",I3.3,")")') &
+ &        LEN_TRIM(key_str)-iund-1
+        READ(UNIT=key_str(iund+2:LEN_TRIM(key_str)), &
+ &           FMT=c_fmt,IOSTAT=io_err) it
+        IF ( (io_err == 0).AND.(it > 0) ) THEN
+          WRITE(UNIT=cnt,FMT=c_i_fmt) it
           key_str = key_str(1:iund+1)//cnt
         ELSE
-          WRITE(*,*) &
- &          'getin_readdef : A very strange key has just been found'
-          WRITE(*,*) 'getin_readdef : ',key_str(1:len_TRIM(key_str))
-          STOP 'getin_readdef'
+          CALL ipslerr (3,'getin_readdef', &
+ &         'A very strange key has just been found :', &
+ &         TRIM(key_str),' ')
         ENDIF
       ENDIF
@@ -1443,14 +1182,14 @@
         ELSE
           IF (nb_lastkey /= 1) THEN
-            WRITE(*,*) &
- &   'getin_readdef : An error has occured. We can not have a scalar'
-            WRITE(*,*) 'getin_readdef : keywod and a vector content'
-            STOP 'getin_readdef'
+            CALL ipslerr (3,'getin_readdef', &
+ &           'We can not have a scalar keyword', &
+ &           'and a vector content',' ')
           ENDIF
 !-------- The last keyword needs to be transformed into a vector.
+          WRITE(UNIT=cnt,FMT=c_i_fmt) 1
           targetlist(nb_lines) = &
- &          last_key(1:MIN(len_trim(last_key),30))//'__001'
+ &         last_key(1:MIN(LEN_TRIM(last_key),l_n-n_d_fmt-2))//'__'//cnt
           CALL gensig (targetlist(nb_lines),targetsiglist(nb_lines))
-          key_str = last_key(1:len_TRIM(last_key))
+          key_str = last_key(1:LEN_TRIM(last_key))
         ENDIF
       ENDIF
@@ -1459,5 +1198,5 @@
       CALL getin_decrypt (current,key_str,NEW_str,last_key,nb_lastkey)
     ELSE
-!---- If we have an empty line the the keyword finishes
+!---- If we have an empty line then the keyword finishes
       nb_lastkey = 0
       IF (check) THEN
